#ifndef MB_DB_H
#define MB_DB_H
/* $Id: db.h,v 1.9 1999/04/28 16:44:42 schwartz Exp $ */

#ifdef SMALL
#define BLOCKLIM  (10)
#define SEQLIM    (3)
#define HDRSAVE   (50)
#else
#define BLOCKLIM  (5000000)
#define SEQLIM    (50000)
#define HDRSAVE   (50)
#endif
#define BLOCKSIZE (BLOCKLIM*2+1)
#define SEQSIZE   (SEQLIM*2+1)

/* This query database stores the concatenation of a number of query
 * sequences, seperated by 'X's, along with the file position, byte
 * offset, and saved header for each sequence.  The reverse-compliment of
 * each sequence is also stored.
 */
struct qdb {
    long fpos[SEQSIZE];
    char hdr[SEQSIZE][HDRSAVE];
    long beg[SEQSIZE];
    unsigned char sequence[BLOCKSIZE];
    unsigned char *p; /* next free position in sequence */
    int nseq;
};
typedef struct qdb qdb_t;

/* extern struct qdb qdb; */
void fmt_id(char *h, int c, char* p);
int qdb_fill_block(FILE *fp, qdb_t *qdb, int);
int qdb_is_revcomp(qdb_t *qdb, int id);
int qdb_length(const qdb_t *qdb, int i);
int qdb_total_length(const qdb_t *qdb);
const unsigned char *qdb_seq(qdb_t *qdb, int i);
#endif
