#ifndef GALIGN_H
#define GALIGN_H
/* $Id: galign.h,v 1.2 1999/04/16 19:33:26 schwartz Exp $ */

/* Basic O(ND) time, O(N) space, alignment function. 
 * Parameters:
 *   s1, len1        - first sequence and its length
 *   s2, len2        - second sequence and its length
 *   reverse         - direction of alignment
 *   xdrop_threshold -
 *   mismatch_cost   -
 *   e1, e2          - endpoint of the computed alignment
 *   edit_script     -
 */

int gap_align_basic(
	const uchar *s1, int len1,
	const uchar *s2, int len2,
	int reverse, int xdrop_threshold, 
	int match_score,
	int mismatch_score,
	int gap_open,
	int gap_extend,
	int *e1, int *e2, edit_script_t *S);

#endif
