#ifndef MB_MB_H
#define MB_MB_H
/* $Id: mb.h,v 1.27 1999/09/24 20:38:27 schwartz Exp $ */

#include "mbalign.h"
#include "unpack.h"

typedef struct mb_table mbt_t;
typedef struct align_params align_params_t;

void mb_search(mbt_t *, unsigned char *, int, int, qdb_t *, char*, align_params_t*);
int est_search(mbt_t *, unsigned char *, int, align_params_t *);

mbt_t *mb_init(void);
void mb_start(mbt_t *mbt, unsigned char *dna, int ld, int w, int p);
void mb_end(mbt_t *mbt);
/*
void mb_blastz_start(mbt_t *mbt, int X, int K, int k, int x);
*/

void mb_print_sequence(unsigned char *seq, int len, char *);
void print_bz_result(int, const char *, const char *);
void print_mb_result(int, const char *, const char *, int, int, int, int, int, int);

void fatal(); /* XXX */

enum {
    MB_DO_EST    = 0,
    MB_DO_GREEDY = 1,
    MB_DO_BZ     = 2
};

enum {
    MB_ALIGN_NONE = 0,
    MB_ALIGN_SUM  = 1,
    MB_ALIGN_LAV  = 2
};

enum {
    MATCH_SCORE_SCALE = 10
};

struct align_params {
    int prog_flag;
    int bzthresh;
    int gap_align_cutoff;
    int gap_extension_penalty;
    int gap_open_penalty;
    int idlen;
    int len_perf_match;
    int match_score;
    int transition_score;
    int transversion_score;
    int max_12mer_ents;
    int mismatch_penalty_bz;
    int mismatch_penalty_mb;
    int normalize_revcomp_flag;
    int xdrop_ext;
    int xdrop_gapfree;
    int output_al;
};

#endif
