#ifndef MB_MBALIGN_H
#define MB_MBALIGN_H
/* $Id: mbalign.h,v 1.7 1999/04/16 20:07:39 schwartz Exp $ */

typedef struct gapped_align {
	struct gapped_align *next;
	int b1, b2, e1, e2;		/* bounding box */
        int diag, length, id;
	int max, prune;
        edit_script_t *S;
} gal_t;

#define GAL_CONTAINS(outer,inner) \
        ((outer)->b1 <= (inner)->b1 && (outer)->b2 <= (inner)->b2 && \
         (outer)->e1 >= (inner)->e1 && (outer)->e2 >= (inner)->e2)
         
#define GAL_CLOSE_ENOUGH 10 /* XXX - arbitrary */

#define GAL_CLOSE(a,b) \
        (abs(((a)->b1 - (a)->b2) - ((b)->b1 - (b)->b2)) < GAL_CLOSE_ENOUGH)


int mb_extend_align       (gal_t*, int, int, const uchar *, int, const uchar *, int);
int mb_extend_align_script(gal_t*, int, int, const uchar *, int, const uchar *, int);

int mb_extend_gap_align       (gal_t *mq, int X, int M, int R, int G, int E, const uchar *s1, int l1, const uchar *s2, int l2);
int mb_extend_gap_align_script(gal_t *mq, int X, int M, int R, int G, int E, const uchar *s1, int l1, const uchar *s2, int l2);
#endif
