#ifndef __lint
static const char rcsid[] =
"$Id: print.c,v 1.18 1999/09/24 20:38:27 schwartz Exp $";
#endif

#include "psublast/libc.h"
#include "psublast/psublast.h"
#include "unpack.h"

void mb_print_sequence(uchar* seq, int len, char *defline)
{
    int i, col, remain;
    uchar ch;
    const unsigned char *const code = fasta_decoding;

    printf(">%s\n", defline);
    for (i = col = 0; i < len / 4; i++) {
	printf("%c%c%c%c",
                code[READDB_UNPACK_BASE_1(seq[i])],
	        code[READDB_UNPACK_BASE_2(seq[i])],
	        code[READDB_UNPACK_BASE_3(seq[i])],
	        code[READDB_UNPACK_BASE_4(seq[i])]);
	col += 4;
	if (col >= 50) {
	    printf("\n");
	    col = 0;
	}
    }
    remain = len % 4;
    if (col == 0 && remain == 0)
	return;
    ch = seq[i];
    for (i = 0; i < remain; ++i) {
	printf("%c", code[READDB_UNPACK_BASE_1(ch)]);
	ch <<= 2;
    }
    printf("\n");
}

static const char *skipword(const char *s)
{
    s += strspn(s, " \t");
    s += strcspn(s, " \t");
    return s;
}

static int nwordlen(int n, const char *s)
{
	const char *t = s;
	while (n-- > 0) {
		t = skipword(t);
	}
	return t-s;
}

void print_bz_result(int idlen, const char *def, const char *hdr)
{
    int nd = idlen+1, nh = idlen+1; /* +1 for the ">" */

    if (idlen < 0) {
	nd = nwordlen(idlen, def);
	nh = nwordlen(idlen, hdr);
    }
    printf("'%.*s'=='%.*s'\n", nd, def, nh, hdr);
}

void print_mb_result(int idlen, const char *def, const char *hdr,
	int b1, int b2, int e1, int e2, int diag, int nl)
{
    int nd = idlen+1, nh = idlen+1; /* +1 for the ">" */

    if (idlen < 0) {
	nd = nwordlen(-idlen, def);
	nh = nwordlen(-idlen, hdr);
            /* nh used to get -idlen+1, but Lukas said he likes this better. */
    }
    printf("'%.*s'=='%.*s' (%d %d %d %d) %d%c",
	nd, def, nh, hdr, b1, b2, e1, e2, diag, nl);
}

